#if !defined(__mobdia_h)              // Sentry, use file only if it's not already included.
#define __mobdia_h

/*  Project pounds

    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    pounds.apx Application
    FILE:         mobdia.h
    AUTHOR:       Slash


    OVERVIEW
    ========
    Class definition for TMobDialog (TDialog).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\static.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\combobox.h>
#include <owl\edit.h>
#include <OWL\DIALOG.H>
//#include <owl\validate.h>

#include "pounds.rh"            // Definition of all resources.
#include "areadoc.h"            // Area file database

//{{TDialog = TMobDialog}}
struct TMobDialogXfer {
    char    NameList[ 255 ];
    char    ShortDescr[ 255 ];
    char    LongDescr[ 255 ];
    char    LookDescr[ 4096 ];
    TComboBoxData  SpecFun;
    TComboBoxData  Race;
    TComboBoxData  Class;
    char    Level[ 255 ];
    BOOL    Male;
    BOOL    Female;
    BOOL    Neuter;
    char    Align[ 255 ];
    BOOL    Sentinel;
    BOOL    Scavenger;
    BOOL    Aggresive;
    BOOL    StayArea;
    BOOL    Wimpy;
    BOOL    TrainPCs;
    BOOL    PracticePCs;
	 BOOL		AggieAll;
    BOOL		IsHealer;
    BOOL		IsUndead;
    BOOL		StayTerrain;
    BOOL    Invisible;
    BOOL    DetectInvis;
    BOOL    DetectHidden;
    BOOL    FaerieFire;
    BOOL    ProtEvil;
    BOOL    Sneak;
    BOOL    Hide;
    BOOL    Flying;
    BOOL    PassDoor;
    BOOL    Sanctuary;
	 BOOL    Blind;
    BOOL		MoveHidden;
    char    VNum[ 255 ];
    BOOL    ProtGood;
//    char    SexIcon[ 255 ];
//    char    SpecIcon[ 255 ];
    char    HitPoints[ 255 ];
    char    ArmorClass[ 255 ];
    char    Thac0[ 255 ];
    BOOL    AssistChance;
    BOOL    AssistAlways;
    BOOL    AssistSame;
    BOOL    AntiMagic;
    BOOL    FireShield;
    BOOL    ImprovedInvis;
    BOOL    Invulnerable;
    BOOL    NoSteal;
    BOOL    NoCharm;
    BOOL		LiveCorpse;
    BOOL		SoulStealer;
    BOOL		CandleGiver;
    BOOL		Smith;
    BOOL		Sleep;
    BOOL		BioFeedback;
    BOOL		AdrenRush;
    BOOL		GiantStr;
    BOOL		Resting;
    BOOL		FastRegen;
};

#define MAX_CUSTOM_SPEC 64

class TMobDialog : public TDialog {
    const TMobile *TheActualMobile;
    int nIndex;
    TMobile WorkMob;
    HICON hMobSexIcon[3];
    char *szCustomSpec[MAX_CUSTOM_SPEC];

public:
    TMobDialog (TWindow* parent, const TMobile *mob, int nNdx,
       TResId resId = IDD_MOBDIA, TModule* module = 0);
    virtual ~TMobDialog ();
    HICON hMobSpecIcon[31];

//{{TMobDialogXFER_DEF}}
protected:
    TEdit *NameList;
    TEdit *ShortDescr;
    TEdit *LongDescr;
    TEdit *LookDescr;
    TComboBox *SpecFun;
    TComboBox *Race;
    TComboBox *Class;
    TEdit *Level;
    TRadioButton *Male;
    TRadioButton *Female;
    TRadioButton *Neuter;
    TEdit *Align;
    TCheckBox *Sentinel;
    TCheckBox *Scavenger;
    TCheckBox *Aggresive;
    TCheckBox *StayArea;
    TCheckBox *Wimpy;
    TCheckBox *TrainPCs;
    TCheckBox *PracticePCs;
	 TCheckBox *AggieAll;
    TCheckBox *IsHealer;
    TCheckBox *IsUndead;
    TCheckBox *StayTerrain;
    TCheckBox *Invisible;
    TCheckBox *DetectInvis;
    TCheckBox *DetectHidden;
    TCheckBox *FaerieFire;
    TCheckBox *ProtEvil;
    TCheckBox *Sneak;
    TCheckBox *Hide;
    TCheckBox *Flying;
    TCheckBox *PassDoor;
    TCheckBox *Sanctuary;
    TCheckBox *Blind;
    TCheckBox *MoveHidden;
    TStatic *VNum;
    TStatic *SexIcon;
    TStatic *SpecIcon;
    TStatic *HitPoints;
    TStatic *ArmorClass;
    TStatic *Thac0;
    TCheckBox *AssistChance;
    TCheckBox *AssistAlways;
    TCheckBox *AssistSame;
    TCheckBox *AntiMagic;
    TCheckBox *FireShield;
    TCheckBox *ImprovedInvis;
    TCheckBox *Invulnerable;
    TCheckBox *NoSteal;
    TCheckBox *NoCharm;
    TCheckBox *LiveCorpse;
    TCheckBox *SoulStealer;
    TCheckBox *CandleGiver;
    TCheckBox *Smith;
    TCheckBox *Sleep;
    TCheckBox *BioFeedback;
    TCheckBox *AdrenRush;
    TCheckBox *GiantStr;
    TCheckBox *Resting;
    TCheckBox *FastRegen;
    TComboBox *ClassName;
    TComboBox *RaceName;

//{{TMobDialogXFER_DEF_END}}
    void LoadTransfer();
    void SaveTransfer();
    void LoadAnotherMobile(const TMobile *);
    void LoadClassRace();
    void SaveClassRace();

//{{TMobDialogVIRTUAL_BEGIN}}
public:
    virtual void SetupWindow ();
//{{TMobDialogVIRTUAL_END}}
    void SetThac0 (int nLevel);

//{{TMobDialogRSP_TBL_BEGIN}}
protected:
    void CmPrev ();
    void CmNext ();
    void CmOk ();
    void CmMakeKeeper ();
    void CmSexChanged ();
    void CmSpecChanged ();
    void CmReadme ();
    void CmHelp ();
    void CmAlwaysAssist ();
    void CmViewResets ();
    void CmMobProg ();
//{{TMobDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TMobDialog);
};    //{{TMobDialog}}

#if 0
class TThacoValidator : public TValidator {
   TMobDialog *mobdia;
public:
   TThacoValidator(TMobDialog *AMobDia) { mobdia = AMobDia; }
   BOOL TThacoValidator::IsValidInput(char far*, BOOL suppressFill);
};
#endif
class TThacoEdit : public TEdit {
   TMobDialog *mobdia;
public:
    TThacoEdit(TMobDialog*   parent,
          int        resourceId,
          UINT       textLen = 0,
          TModule*   module = 0):
       TEdit(parent, resourceId, textLen, module)
       { mobdia = parent; }

  protected:
    void         EvKillFocus(HWND hWndGetFocus);
  DECLARE_RESPONSE_TABLE(TThacoEdit);
};
#endif                                      // __mobdia_h sentry.

