/*  Project pounds

    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    pounds.apx Application
    FILE:         objdia.cpp
    AUTHOR:       Slash


    OVERVIEW
    ========
    Source file for implementation of TObjDialog (TDialog).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "objdia.h"
#include "xtradia.h"
#include "appdia.h"

//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TObjDialog, TDialog)
    EV_BN_CLICKED(IDC_PREV, CmPrev),
    EV_BN_CLICKED(IDC_NEXT, CmNext),
    EV_BN_CLICKED(IDC_LIGHT, CmTypeChanged),
    EV_BN_CLICKED(IDC_SCROLL, CmTypeChanged),
    EV_BN_CLICKED(IDC_WAND, CmTypeChanged),
    EV_BN_CLICKED(IDC_STAFF, CmTypeChanged),
    EV_BN_CLICKED(IDC_WEAPON, CmTypeChanged),
    EV_BN_CLICKED(IDC_TREASURE, CmTypeChanged),
    EV_BN_CLICKED(IDC_POTION, CmTypeChanged),
    EV_BN_CLICKED(IDC_FURNITURE, CmTypeChanged),
    EV_BN_CLICKED(IDC_TRASH, CmTypeChanged),
    EV_BN_CLICKED(IDC_CONTAINER, CmTypeChanged),
    EV_BN_CLICKED(IDC_DRINK, CmTypeChanged),
    EV_BN_CLICKED(IDC_KEY, CmTypeChanged),
    EV_BN_CLICKED(IDC_FOOD, CmTypeChanged),
    EV_BN_CLICKED(IDC_GOLD, CmTypeChanged),
    EV_BN_CLICKED(IDC_NPC_CORPSE, CmTypeChanged),
    EV_BN_CLICKED(IDC_FOUNTAIN, CmTypeChanged),
    EV_BN_CLICKED(IDC_PILL, CmTypeChanged),
    EV_BN_CLICKED(IDC_BOAT, CmTypeChanged),
    EV_BN_CLICKED(IDC_TAKE, CmTakeChanged),
    EV_BN_CLICKED(IDC_EDITEXTRA, CmEditExtra),
    EV_BN_CLICKED(IDOK, CmOk),
    EV_LBN_SELCHANGE(IDC_APPLIES_LIST, CmApplySelected),
    EV_BN_CLICKED(IDC_ADDEXTRA, CmAddExtra),
    EV_BN_CLICKED(IDC_DELEXTRA, CmDelExtra),
    EV_BN_CLICKED(IDC_ADDAPPLY, CmAddApply),
    EV_BN_CLICKED(IDC_DELETEAPPLY, CmDelApply),
    EV_LBN_DBLCLK(IDC_EXTRADESCR, CmEditExtra),
    EV_BN_CLICKED(IDC_ARMOR, CmTypeChanged),
    EV_BN_CLICKED(IDC_FINGER, CmWieldChanged),
    EV_BN_CLICKED(IDC_NECK, CmWieldChanged),
    EV_BN_CLICKED(IDC_BODY, CmWieldChanged),
    EV_BN_CLICKED(IDC_HEAD, CmWieldChanged),
    EV_BN_CLICKED(IDC_LEGS, CmWieldChanged),
    EV_BN_CLICKED(IDC_FEET, CmWieldChanged),
    EV_BN_CLICKED(IDC_HANDS, CmWieldChanged),
    EV_BN_CLICKED(IDC_ARMS, CmWieldChanged),
    EV_BN_CLICKED(IDC_SHIELD, CmWieldChanged),
    EV_BN_CLICKED(IDC_ABOUTBODY, CmWieldChanged),
    EV_BN_CLICKED(IDC_WAIST, CmWieldChanged),
    EV_BN_CLICKED(IDC_WRIST, CmWieldChanged),
    EV_BN_CLICKED(IDC_WIELD, CmWieldChanged),
    EV_BN_CLICKED(IDC_HOLD, CmWieldChanged),
    EV_BN_CLICKED(IDC_WITHPRIDE, CmWieldChanged),
    EV_BN_CLICKED(IDHELP, CmHelp),
    EV_BN_CLICKED(IDC_PORTAL, CmTypeChanged),
    EV_BN_CLICKED(IDC_TICKET, CmTypeChanged),
END_RESPONSE_TABLE;





static TObjDialogXfer TObjDialogData;

TObjDialog::TObjDialog (TWindow* parent, const TObject *obj, int nNdx,
        TResId resId, TModule* module):
    TDialog(parent, resId, module), WorkObj( *obj )
{

    NameList = new TEdit(this, IDC_NAMELIST, 255);
    ShortDescr = new TEdit(this, IDC_SHORTDESCR, 255);
    LongDescr = new TEdit(this, IDC_LONGDESCR, 2048);
    Light = new TRadioButton(this, IDC_LIGHT, 0);
    Scroll = new TRadioButton(this, IDC_SCROLL, 0);
    Wand = new TRadioButton(this, IDC_WAND, 0);
    Staff = new TRadioButton(this, IDC_STAFF, 0);
    Weapon = new TRadioButton(this, IDC_WEAPON, 0);
    Armor = new TRadioButton(this, IDC_ARMOR, 0);
    Potion = new TRadioButton(this, IDC_POTION, 0);
    Furniture = new TRadioButton(this, IDC_FURNITURE, 0);
    Trash = new TRadioButton(this, IDC_TRASH, 0);
    Container = new TRadioButton(this, IDC_CONTAINER, 0);
    DrinkCon = new TRadioButton(this, IDC_DRINK, 0);
    Key = new TRadioButton(this, IDC_KEY, 0);
    Food = new TRadioButton(this, IDC_FOOD, 0);
    Gold = new TRadioButton(this, IDC_GOLD, 0);
    Boat = new TRadioButton(this, IDC_BOAT, 0);
    NPCCorpse = new TRadioButton(this, IDC_NPC_CORPSE, 0);
    Fountain = new TRadioButton(this, IDC_FOUNTAIN, 0);
    Pill = new TRadioButton(this, IDC_PILL, 0);
    ObjType = new TStatic(this, IDC_OBJTYPE, 255);
    Take = new TCheckBox(this, IDC_TAKE, 0);
    Finger = new TCheckBox(this, IDC_FINGER, 0);
    Neck = new TCheckBox(this, IDC_NECK, 0);
    Body = new TCheckBox(this, IDC_BODY, 0);
    Head = new TCheckBox(this, IDC_HEAD, 0);
    Legs = new TCheckBox(this, IDC_LEGS, 0);
    Feet = new TCheckBox(this, IDC_FEET, 0);
    Hands = new TCheckBox(this, IDC_HANDS, 0);
    Arms = new TCheckBox(this, IDC_ARMS, 0);
    Shield = new TCheckBox(this, IDC_SHIELD, 0);
    AboutBody = new TCheckBox(this, IDC_ABOUTBODY, 0);
    Waist = new TCheckBox(this, IDC_WAIST, 0);
    Wrist = new TCheckBox(this, IDC_WRIST, 0);
    Hold = new TCheckBox(this, IDC_HOLD, 0);
    WithPride = new TCheckBox(this, IDC_WITHPRIDE, 0);
    Glow = new TCheckBox(this, IDC_GLOW, 0);
    Hum = new TCheckBox(this, IDC_HUM, 0);
    Evil = new TCheckBox(this, IDC_EVIL, 0);
    Magic = new TCheckBox(this, IDC_MAGIC, 0);
    NoDrop = new TCheckBox(this, IDC_NODROP, 0);
    AntiGood = new TCheckBox(this, IDC_ANTIGOOD, 0);
    AntiEvil = new TCheckBox(this, IDC_ANTIEVIL, 0);
    AntiNeutral = new TCheckBox(this, IDC_ANTINEUTRAL, 0);
    NoRemove = new TCheckBox(this, IDC_NOREMOVE, 0);
    Invis = new TCheckBox(this, IDC_INVIS, 0);
    Good = new TCheckBox(this, IDC_GOOD, 0 );
    Dark = new TCheckBox(this, IDC_DARK, 0 );
    Bless = new TCheckBox(this, IDC_BLESS, 0 );
    Inventory = new TCheckBox(this, IDC_INVENTORY, 0 );
    NoLocate = new TCheckBox(this, IDC_NOLOCATE, 0 );
    Timer = new TCheckBox(this, IDC_TIMER, 0 );
    Dull = new TCheckBox(this, IDC_DULL, 0 );
    Sharp = new TCheckBox(this, IDC_SHARP, 0 );
    VNum = new TStatic(this, IDC_VNUM, 255);
    Wield = new TCheckBox(this, IDC_WIELD, 0);
    Weight = new TEdit(this, IDC_WEIGHT, 255);
    Treasure = new TRadioButton(this, IDC_TREASURE, 0);

    for (int i = 0; i < 4; i++)
       {
       Prompt[i] = new TStatic(this, IDC_PROMPT1 + i, 32);
       Value[i] = new TComboBox(this, IDC_VALUE1 + i, 32);
       }
    AppliesList = new TListBox(this, IDC_APPLIES_LIST);
    ApplyAmount = new TEdit(this, IDC_APPLY_AMOUNT, 255);
    ExtraList = new TListBox(this, IDC_EXTRADESCR);
    WieldType = new TStatic(this, IDC_WIELDTYPE, 255);
    Limit = new TStatic(this, IDC_LIMIT, 255);
    Ticket = new TRadioButton(this, IDC_TICKET, 0);
    Portal = new TRadioButton(this, IDC_PORTAL, 0);

    SetTransferBuffer(&TObjDialogData);


    // INSERT>> Your constructor code here.
    TheActualObject = obj;
    nIndex = nNdx;

    VNum->EnableTransfer();
    Limit->EnableTransfer();
    LoadTransfer();

    static int nIconIDs[] = { IDI_LIGHT, IDI_SCROLL, IDI_WAND, IDI_STAFF,
       IDI_WEAPON, IDI_OBJECTS, IDI_OBJECTS, IDI_TREASURE, IDI_ARMOR,
       IDI_POTION, IDI_OBJECTS, IDI_FURNITURE, IDI_TRASH, IDI_OBJECTS,
       IDI_CONTAINER,
       IDI_OBJECTS, IDI_DRINK_CON, IDI_KEY,
       IDI_FOOD, IDI_GOLD, IDI_OBJECTS, IDI_BOAT,
       IDI_NPC_CORPSE, IDI_OBJECTS /* @@@ sb pc corpse*/,
       IDI_FOUNTAIN, IDI_PILL,
       // Custom types
       IDI_OBJECTS, IDI_OBJECTS };       // 28

    for (i = 0; i < nelems(hObjTypeIcon); i++)
       hObjTypeIcon[i] = GetApplication()->LoadIcon(MAKEINTRESOURCE(nIconIDs[i]));

    static int nLookupArmorIcon[] = { IDI_NOTAKE, IDI_TOMANYWIELDS,
       IDI_TAKE, IDI_FINGER, IDI_NECK, IDI_BODY,
       IDI_HEAD, IDI_LEGS, IDI_FEET, IDI_HANDS, IDI_ARMS, IDI_SHIELD,
       IDI_ABOUTBODY, IDI_WAIST, IDI_WRIST, IDI_WIELD, IDI_HOLD, IDI_PRIDE };

    for (i = 0; i < nelems(hWearIcon); i++)
       hWearIcon[i] = GetApplication()->LoadIcon(MAKEINTRESOURCE(
          nLookupArmorIcon[i]));
}


TObjDialog::~TObjDialog ()
{
    Destroy();

    // INSERT>> Your destructor code here.
    for (int i = 0; i < nelems(hObjTypeIcon); i++)
       DestroyIcon(hObjTypeIcon[i]);
    for (i = 0; i < nelems(hWearIcon); i++)
       DestroyIcon(hWearIcon[i]);
}


void TObjDialog::CmPrev ()
{
    // INSERT>> Your code here.
    const TObject *o;
    if ((o = WorkObj.AreaDoc->GetObjectFromIndex(nIndex-1)) != 0)
       {
   	 TransferData(tdGetData);
       SaveTransfer();
       nIndex--;
       LoadAnotherObject(o);
       return;
       }

    MessageBeep(-1);
}


void TObjDialog::CmNext ()
{
    // INSERT>> Your code here.
    const TObject *o;
    if ((o = WorkObj.AreaDoc->GetObjectFromIndex(nIndex+1)) != 0)
       {
   	 TransferData(tdGetData);
       SaveTransfer();
       nIndex++;
       LoadAnotherObject(o);
       return;
       }

    MessageBeep(-1);
}

const char *TObjDialog::GetAffectName(int n)
{
   static char * FAR szNames[] = {
      "None", "Strength", "Dexterity", "Intelligence", "Wisdom", "Constitution",
      "Sex", "Class", "Level", "Age", "Height", "Weight",
      "Mana", "Hit points", "Moves", "Gold", "Experience",
      "Armor Class", "Hit roll", "Damage Roll", "Save vs Paralysis",
      "Save vs Rod", "Save vs Petrification", "Save vs Breath",
      "Save vs Spell", //next is 25
      "Sanctuary", "Flying", "Blind", "Invisible", "Detect Evil", "Detect Magic",
      "Detect Hidden", "Faerie Fire", "Infrared", "Curse",
      "Poison", "Protect", "Sneak", "Hide", "Pass Door", "Plague",
      "Endurance"  // last is 42
   };

   if (n < nelems(szNames))
      return szNames[n];
   return "Error";
}

void TObjDialog::LoadTransfer()
{
    strcpy(TObjDialogData.NameList, WorkObj.name.c_str());
    strcpy(TObjDialogData.ShortDescr, WorkObj.short_descr.c_str());
    strcpy(TObjDialogData.LongDescr, WorkObj.description.c_str());

    // Item type
    TObjDialogData.Light = (WorkObj.item_type == ITEM_LIGHT);
    TObjDialogData.Scroll = (WorkObj.item_type == ITEM_SCROLL);
    TObjDialogData.Wand = (WorkObj.item_type == ITEM_WAND);
    TObjDialogData.Staff = (WorkObj.item_type == ITEM_STAFF);
    TObjDialogData.Weapon = (WorkObj.item_type == ITEM_WEAPON);
    TObjDialogData.Treasure = (WorkObj.item_type == ITEM_TREASURE);
    TObjDialogData.Armor = (WorkObj.item_type == ITEM_ARMOR);
    TObjDialogData.Potion = (WorkObj.item_type == ITEM_POTION);
    TObjDialogData.Furniture = (WorkObj.item_type == ITEM_FURNITURE);
    TObjDialogData.Trash = (WorkObj.item_type == ITEM_TRASH);
    TObjDialogData.Container = (WorkObj.item_type == ITEM_CONTAINER);
    TObjDialogData.DrinkCon = (WorkObj.item_type == ITEM_DRINK_CON);
    TObjDialogData.Key = (WorkObj.item_type == ITEM_KEY);
    TObjDialogData.Food = (WorkObj.item_type == ITEM_FOOD);
    TObjDialogData.Gold = (WorkObj.item_type == ITEM_MONEY);
    TObjDialogData.Boat = (WorkObj.item_type == ITEM_BOAT);
    TObjDialogData.Fountain = (WorkObj.item_type == ITEM_FOUNTAIN);
    TObjDialogData.Pill = (WorkObj.item_type == ITEM_PILL);
    TObjDialogData.Ticket = (WorkObj.item_type == ITEM_TICKET);
    TObjDialogData.Portal = (WorkObj.item_type == ITEM_PORTAL);
    
    // Wear position
    TObjDialogData.Take = IS_SET(WorkObj.wear_flags, ITEM_TAKE);
    TObjDialogData.Finger =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_FINGER);
    TObjDialogData.Neck =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_NECK);
    TObjDialogData.Body =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_BODY);
    TObjDialogData.Head =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_HEAD);
    TObjDialogData.Legs =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_LEGS);
    TObjDialogData.Feet =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_FEET);
    TObjDialogData.Hands =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_HANDS);
    TObjDialogData.Arms =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_ARMS);
    TObjDialogData.Shield =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_SHIELD);
    TObjDialogData.AboutBody =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_ABOUT);
    TObjDialogData.Waist =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_WAIST);
    TObjDialogData.Wrist =  IS_SET(WorkObj.wear_flags, ITEM_WEAR_WRIST);
    TObjDialogData.Wield =  IS_SET(WorkObj.wear_flags, ITEM_WIELD);
    TObjDialogData.Hold =  IS_SET(WorkObj.wear_flags, ITEM_HOLD);
    TObjDialogData.WithPride =  IS_SET(WorkObj.wear_flags, ITEM_WORN_PRIDE);

    // Extra flags
    TObjDialogData.Glow = IS_SET(WorkObj.extra_flags, ITEM_GLOW);
    TObjDialogData.Hum = IS_SET(WorkObj.extra_flags, ITEM_HUM);
    TObjDialogData.Evil = IS_SET(WorkObj.extra_flags, ITEM_EVIL);
    TObjDialogData.Magic = IS_SET(WorkObj.extra_flags, ITEM_MAGIC);
    TObjDialogData.NoDrop = IS_SET(WorkObj.extra_flags, ITEM_NODROP);
    TObjDialogData.AntiGood = IS_SET(WorkObj.extra_flags, ITEM_ANTI_GOOD);
    TObjDialogData.AntiEvil = IS_SET(WorkObj.extra_flags, ITEM_ANTI_EVIL);
    TObjDialogData.AntiNeutral = IS_SET(WorkObj.extra_flags, ITEM_ANTI_NEUTRAL);
    TObjDialogData.NoRemove = IS_SET(WorkObj.extra_flags, ITEM_NOREMOVE);
    TObjDialogData.Invis = IS_SET(WorkObj.extra_flags, ITEM_INVIS);
    TObjDialogData.Good = IS_SET(WorkObj.extra_flags, ITEM_GOOD);
    TObjDialogData.Dark = IS_SET(WorkObj.extra_flags, ITEM_DARK );
    TObjDialogData.Bless = IS_SET(WorkObj.extra_flags, ITEM_BLESS);
    TObjDialogData.Inventory = IS_SET(WorkObj.extra_flags, ITEM_INVENTORY);
    TObjDialogData.NoLocate = IS_SET(WorkObj.extra_flags, ITEM_NOLOCATE);
    TObjDialogData.Timer = IS_SET(WorkObj.extra_flags, ITEM_TIMER);
    TObjDialogData.Dull = IS_SET(WorkObj.extra_flags, ITEM_DULL);
    TObjDialogData.Sharp = IS_SET(WorkObj.extra_flags, ITEM_SHARP);

    wsprintf(TObjDialogData.VNum, "%d", WorkObj.vnum);
    wsprintf(TObjDialogData.Limit, "%ld", WorkObj.count);		// @@@ TFC only
    wsprintf(TObjDialogData.Weight, "%ld", WorkObj.weight);

    TObjDialogData.AppliesList.Clear();
    BOOL fFirst = TRUE;
    for (TArrayAsVectorIterator<TAffect *> it(WorkObj.affected); it; it++)
       {
       TObjDialogData.AppliesList.AddString(
          GetAffectName(it.Current()->location), fFirst);
       fFirst = FALSE;
       }

    TObjDialogData.ExtraList.Clear();
    for (TArrayAsVectorIterator<TExtraDescr *> it2(WorkObj.extra_descr); it2; it2++)
       TObjDialogData.ExtraList.AddString(it2.Current()->keyword.c_str());
}

void TObjDialog::SaveTransfer()
{
    SaveValues();

    WorkObj.name = TObjDialogData.NameList;
    WorkObj.short_descr = TObjDialogData.ShortDescr;
    WorkObj.description = TObjDialogData.LongDescr;

    // Item type
    if (TObjDialogData.Light)          WorkObj.item_type = ITEM_LIGHT;
    else if (TObjDialogData.Scroll)    WorkObj.item_type = ITEM_SCROLL;
    else if (TObjDialogData.Wand) 		WorkObj.item_type = ITEM_WAND;
    else if (TObjDialogData.Staff) 		WorkObj.item_type = ITEM_STAFF;
    else if (TObjDialogData.Weapon) 	WorkObj.item_type = ITEM_WEAPON;
    else if (TObjDialogData.Treasure) 	WorkObj.item_type = ITEM_TREASURE;
    else if (TObjDialogData.Armor) 		WorkObj.item_type = ITEM_ARMOR;
    else if (TObjDialogData.Potion) 	WorkObj.item_type = ITEM_POTION;
    else if (TObjDialogData.Furniture) WorkObj.item_type = ITEM_FURNITURE;
    else if (TObjDialogData.Trash) 		WorkObj.item_type = ITEM_TRASH;
    else if (TObjDialogData.Container) WorkObj.item_type = ITEM_CONTAINER;
    else if (TObjDialogData.DrinkCon)  WorkObj.item_type = ITEM_DRINK_CON;
    else if (TObjDialogData.Key) 		WorkObj.item_type = ITEM_KEY;
    else if (TObjDialogData.Food) 		WorkObj.item_type = ITEM_FOOD;
    else if (TObjDialogData.Gold) 		WorkObj.item_type = ITEM_MONEY;
    else if (TObjDialogData.Boat) 		WorkObj.item_type = ITEM_BOAT;
    else if (TObjDialogData.Fountain)  WorkObj.item_type = ITEM_FOUNTAIN;
    else if (TObjDialogData.Pill)  		WorkObj.item_type = ITEM_PILL;
    else if (TObjDialogData.Ticket)    WorkObj.item_type = ITEM_TICKET;
    else if (TObjDialogData.Portal)		WorkObj.item_type = ITEM_PORTAL;

    // Wear position
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Take, ITEM_TAKE);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Finger, ITEM_WEAR_FINGER);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Neck, ITEM_WEAR_NECK);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Body, ITEM_WEAR_BODY);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Head, ITEM_WEAR_HEAD);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Legs, ITEM_WEAR_LEGS);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Feet, ITEM_WEAR_FEET);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Hands, ITEM_WEAR_HANDS);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Arms, ITEM_WEAR_ARMS);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Shield, ITEM_WEAR_SHIELD);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.AboutBody, ITEM_WEAR_ABOUT);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Waist, ITEM_WEAR_WAIST);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Wrist, ITEM_WEAR_WRIST);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Wield, ITEM_WIELD);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.Hold, ITEM_HOLD);
    SET_RESET_BIT(WorkObj.wear_flags, TObjDialogData.WithPride, ITEM_WORN_PRIDE);

    // Extra flags
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Glow, ITEM_GLOW);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Hum, ITEM_HUM);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Evil, ITEM_EVIL);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Magic, ITEM_MAGIC);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.NoDrop, ITEM_NODROP);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.AntiGood, ITEM_ANTI_GOOD);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.AntiEvil, ITEM_ANTI_EVIL);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.AntiNeutral, ITEM_ANTI_NEUTRAL);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.NoRemove, ITEM_NOREMOVE);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Invis, ITEM_INVIS);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Good, ITEM_GOOD);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Dark, ITEM_DARK);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Bless, ITEM_BLESS);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Inventory, ITEM_INVENTORY);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.NoLocate, ITEM_NOLOCATE);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Timer, ITEM_TIMER);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Dull, ITEM_DULL);
    SET_RESET_BIT(WorkObj.extra_flags, TObjDialogData.Sharp, ITEM_SHARP);

    // Weight
    WorkObj.weight = atoi(TObjDialogData.Weight);

	 // Save possible changes to current apply
    char szBuffer[16];
    if (nCurrApply >= 0)
       {
		 ApplyAmount->GetText(szBuffer, sizeof szBuffer);
       WorkObj.affected[nCurrApply]->modifier = (sh_int) atoi(szBuffer);
       }

    WorkObj.AreaDoc->ObjectSave(WorkObj, nIndex);
}

void TObjDialog::LoadAnotherObject(const TObject *o)
{
   TheActualObject = o;
   WorkObj = *o;
   LoadTransfer();
   TransferData(tdSetData);
   CmTakeChanged();
//   CmWieldChanged();
   CmTypeChanged();
   nCurrApply = -1;
   CmApplySelected ();
}

void TObjDialog::SetPrompts()
{

 	  static char *szPrompts[28][4] = {
      { "Unused", "Unused", "Hours", "Unused" },			 	// light
      { "Level", "Spell #1", "Spell #2", "Spell #3" },      // scroll
      { "Level", "Max Charges", "Charges Left", "Spell" },		// wand
      { "Level", "Max Charges", "Charges Left", "Spell" },		// staff
      { "Unused", "Unused", "Unused", "Type" },						   // weapon
      { "MobVnum to Activate", "Room/Object Vnum", "Unused", "Type" },  // ticket
      { "?", "?", "?", "?" },                                //
		{ "Unused", "Unused", "Unused", "Unused" },			    // treasure
		{ "Unused", "Unused", "Unused", "Unused" },				// armor
      { "Level", "Spell #1", "Spell #2", "Spell #3" },    	// potion
      { "?", "?", "?", "?" },                               //
      { "Unused", "Unused", "Unused", "Unused" },			   // furniture
      { "Unused", "Unused", "Unused", "Unused" },		    	// trash
      { "?", "?", "?", "?" },                               //
		{ "Capacity", "Flags", "Key", "Trap Type" },				// container
      { "?", "?", "?", "?" },                               //
		{ "Capacity", "Current Amt", "Liquid Type", "Poison?" },		// drink
      { "Unused", "Unused", "Unused", "Unused" },					// key
      { "Hours", "Unused", "Unused", "Poisoned?" },			// food
      { "# Coins", "Unused", "Unused", "Unused" },			  	// gold
      { "?", "?", "?", "?" },
      { "Unused", "Unused", "Unused", "Unused" },				// boat
      { "Unused", "Unused", "Unused", "Unused" },			  	// corpse
      { "?", "?", "?", "?" },                               // (no PC corpses!)
      { "'Good' Spell", "'Bad' Spell", "Unused", "Flags (see docs)" },		 	// fountain
      { "Level", "Spell #1", "Spell #2", "Spell #3" },           		// pill
      { "", "", "", "" },												//
      { "Room Vnum", "Unused", "Unused", "Unused" },			// portal
   };

   int nType = 0;
   if (Light->GetCheck() == BF_CHECKED)
      nType = ITEM_LIGHT;
   else if (Scroll->GetCheck() == BF_CHECKED)
      nType = ITEM_SCROLL;
   else if (Wand->GetCheck() == BF_CHECKED)
      nType = ITEM_WAND;
   else if (Staff->GetCheck() == BF_CHECKED)
      nType = ITEM_STAFF;
   else if (Weapon->GetCheck() == BF_CHECKED)
      nType = ITEM_WEAPON;
   else if (Treasure->GetCheck() == BF_CHECKED)
      nType = ITEM_TREASURE;
   else if (Armor->GetCheck() == BF_CHECKED)
      nType = ITEM_ARMOR;
   else if (Potion->GetCheck() == BF_CHECKED)
      nType = ITEM_POTION;
   else if (Furniture->GetCheck() == BF_CHECKED)
      nType = ITEM_FURNITURE;
   else if (Trash->GetCheck() == BF_CHECKED)
      nType = ITEM_TRASH;
   else if (Container->GetCheck() == BF_CHECKED)
      nType = ITEM_CONTAINER;
   else if (DrinkCon->GetCheck() == BF_CHECKED)
      nType = ITEM_DRINK_CON;
   else if (Key->GetCheck() == BF_CHECKED)
      nType = ITEM_KEY;
   else if (Food->GetCheck() == BF_CHECKED)
      nType = ITEM_FOOD;
   else if (Gold->GetCheck() == BF_CHECKED)
      nType = ITEM_MONEY;
   else if (Boat->GetCheck() == BF_CHECKED)
      nType = ITEM_BOAT;
   else if (Fountain->GetCheck() == BF_CHECKED)
      nType = ITEM_FOUNTAIN;
   else if (Pill->GetCheck() == BF_CHECKED)
      nType = ITEM_PILL;
   else if (Ticket->GetCheck() == BF_CHECKED)
      nType = ITEM_TICKET;
   else if (Portal->GetCheck() == BF_CHECKED)
      nType = ITEM_PORTAL;

   if (nType < 1 || nType > nelems(szPrompts))
      nType = 28;
   for (int i = 0; i < 4; i++)
      Prompt[i]->SetText(szPrompts[nType-1][i]);

   nCurrentType = nType;
//   Metallic->EnableWindow(nCurrentType == ITEM_ARMOR &&
//                             WorkObj.AreaDoc->GetMode() == poundsApp::TFCMode);
}


void TObjDialog::CmTypeChanged ()
{
    // INSERT>> Your code here.
    SetPrompts();
    LoadValues();
    ObjType->SendMessage(STM_SETICON, (WPARAM) hObjTypeIcon[nCurrentType-1], 0);
}


void TObjDialog::CmTakeChanged ()
{
    // INSERT>> Your code here.
    BOOL fTakable = (Take->GetCheck() == BF_CHECKED);

    Finger->EnableWindow(fTakable);
    Neck->EnableWindow(fTakable);
    Body->EnableWindow(fTakable);
    Head->EnableWindow(fTakable);
    Legs->EnableWindow(fTakable);
    Feet->EnableWindow(fTakable);
    Hands->EnableWindow(fTakable);
    Arms->EnableWindow(fTakable);
    Shield->EnableWindow(fTakable);
    AboutBody->EnableWindow(fTakable);
    Waist->EnableWindow(fTakable);
    Wrist->EnableWindow(fTakable);
    Wield->EnableWindow(fTakable);
    Hold->EnableWindow(fTakable);
    WithPride->EnableWindow(fTakable &&
                            WorkObj.AreaDoc->GetMode() == poundsApp::TFCMode);

    CmWieldChanged();
}


void TObjDialog::SetupWindow ()
{
    TDialog::SetupWindow();

    // INSERT>> Your code here.
    LongDescr->SendMessage(WM_SETFONT,
       (WPARAM) (HFONT) WorkObj.AreaDoc->GetMZF()->hFixedFont, 0);




    CmTakeChanged();
    CmTypeChanged();
    nCurrApply = -1;
    CmApplySelected();
//    CmWieldChanged();
}

void TObjDialog::LoadValues()
{
    // @@@ use nCurrentType
    int32 nVal[4];
    for (int i = 0; i < 4; i++)
       {
       Value[i]->ClearList();
//       Value[i]->AddString(WorkObj.value[i].c_str());
//       Value[i]->SetText(WorkObj.value[i].c_str());
       nVal[i] = atol(WorkObj.value[i].c_str());
       }

    const char *szText; // = 0;
    int n;
    int nSlot;
    switch (nCurrentType)
       {
       case ITEM_WEAPON:
          for (i = 0; i < 3; i++)
             {
             Value[i]->AddString(WorkObj.value[i].c_str());
             Value[i]->SetText(WorkObj.value[i].c_str());
             }

          n = 0;
		    szText = TAreaDocument::DamageType(n);
          while (szText)
             {
             Value[3]->AddString(szText);
             if (n == nVal[3])
                Value[3]->SetText(szText);
             n++;
             szText = TAreaDocument::DamageType(n);
             }
          break;

       case ITEM_TICKET:
          for (i = 0; i < 3; i++ )
            {
              Value[i]->AddString(WorkObj.value[i].c_str());
              Value[i]->SetText(WorkObj.value[i].c_str());
            }

    		 Value[3]->AddString("Room Ticket");
          Value[3]->AddString("Object Ticket");
          Value[3]->SetText((nVal[3]) ? "Object Ticket" : "Room Ticket");
          break;

       case ITEM_SCROLL:
       case ITEM_POTION:
       case ITEM_PILL:
          Value[0]->AddString(WorkObj.value[0].c_str());
          Value[0]->SetText(WorkObj.value[0].c_str());

#if 0
          // @@@ This needs to handle unknown spell #s
          for (n = -1; n <= TAreaDocument::MaxSpell(); n++)
             {
             szText = TAreaDocument::SpellName(n);
             if (szText)
                for (i = 1; i < 4; i++)
                   {
                   Value[i]->AddString(szText);
                   if (nVal[i] == n)
                      Value[i]->SetText(szText);
                   }
             }
#else
          n = 0;
          while ((szText = TAreaDocument::SpellIndex(n, &nSlot)) != 0)
           {
           if (nSlot != 0)
             {
             for (i = 1; i < 4; i++)
                {
                Value[i]->AddString(szText);
                if (nVal[i] == nSlot)
                   Value[i]->SetText(szText);
                }
             }
           n++;
           }
#endif
          break;

       case ITEM_WAND:
       case ITEM_STAFF:
          for (i = 0; i < 3; i++)
             {
             Value[i]->AddString(WorkObj.value[i].c_str());
             Value[i]->SetText(WorkObj.value[i].c_str());
             }

#if 0
          // @@@ This needs to handle unknown spell #s
          for (n = -1; n <= TAreaDocument::MaxSpell(); n++)
             {
             szText = TAreaDocument::SpellName(n);
             if (szText)
                {
                Value[3]->AddString(szText);
                if (nVal[3] == n)
                   Value[3]->SetText(szText);
                }
             }
#else
          n = 0;
          while ((szText = TAreaDocument::SpellIndex(n, &nSlot)) != 0)
            {
            if (nSlot != 0)
             {
             Value[3]->AddString(szText);
             if (nVal[3] == nSlot)
                Value[3]->SetText(szText);
             }
            n++;
            }
#endif
          break;

       case ITEM_CONTAINER:
//@@@   value[0]    weight capacity
//@@@   value[1]    flags: 1 closeable, 2 pickproof, 4 closed, 8 locked
//@@@   value[2]    key vnum
//@@@   value[3]    unused
          for (i = 0; i < 4; i++)
             {
             Value[i]->AddString(WorkObj.value[i].c_str());
             Value[i]->SetText(WorkObj.value[i].c_str());
             }

          n = 0;
		    szText = TAreaDocument::ContainerFlags(n);
          Value[1]->ClearList();
          while (szText)
             {
             Value[1]->AddString(szText);
             if (n == nVal[1])
                Value[1]->SetText(szText);
             n++;
             szText = TAreaDocument::ContainerFlags(n);
             }

          n = 0;
		    szText = TAreaDocument::ContainerTrapType(n);
          Value[3]->ClearList();
          while (szText)
             {
             Value[3]->AddString(szText);
             if (n == nVal[3])
                Value[3]->SetText(szText);
             n++;
             szText = TAreaDocument::ContainerTrapType(n);
             }

          break;

       case ITEM_DRINK_CON:
          for (i = 0; i < 2; i++)
             {
             Value[i]->AddString(WorkObj.value[i].c_str());
             Value[i]->SetText(WorkObj.value[i].c_str());
             }

          n = 0;
		    szText = TAreaDocument::LiquidType(n);
          while (szText)
             {
             Value[2]->AddString(szText);
             if (n == nVal[2])
                Value[2]->SetText(szText);
             n++;
             szText = TAreaDocument::LiquidType(n);
             }

          Value[3]->AddString("non-poison");
          Value[3]->AddString("Poison!");
          Value[3]->SetText((nVal[3]) ? "Poison!" : "non-poison");
          break;

         case ITEM_FOOD:
           for (i = 0; i < 4; i++)
             {
             Value[i]->AddString(WorkObj.value[i].c_str());
             Value[i]->SetText(WorkObj.value[i].c_str());
             }

          Value[3]->ClearList();
          Value[3]->AddString("non-poison");
          Value[3]->AddString("Poison!");
          Value[3]->SetText((nVal[3]) ? "Poison!" : "non-poison");
          break;

         case ITEM_FOUNTAIN:

#if 0
          // @@@ This needs to handle unknown spell #s
          for (n = -1; n <= TAreaDocument::MaxSpell(); n++)
             {
             szText = TAreaDocument::SpellName(n);
             if (szText)
                for (i = 0; i < 2; i++)
                   {
                   Value[i]->AddString(szText);
                   if (nVal[i] == n)
                      Value[i]->SetText(szText);
                   }
             }
#else
          n = 0;
          while ((szText = TAreaDocument::SpellIndex(n, &nSlot)) != 0)
           {
           if (nSlot != 0)
             {
             for (i = 0; i < 2; i++)
                {
                Value[i]->AddString(szText);
                if (nVal[i] == nSlot)
                   Value[i]->SetText(szText);
                }
             }
           n++;
           }
#endif

          // Value 3 -- fountain bits..needs to be redone
          Value[3]->AddString(WorkObj.value[3].c_str());
          Value[3]->SetText(WorkObj.value[3].c_str());
          break;


//       case ITEM_FURNITURE:
//       case ITEM_TRASH:
//       case ITEM_TREASURE:
//       case ITEM_ARMOR:
//       case ITEM_LIGHT:
//       case ITEM_KEY:
//       case ITEM_MONEY:
//       case ITEM_BOAT:
//       case ITEM_CORPSE_NPC:


       default:
          for (i = 0; i < 4; i++)
             {
             Value[i]->AddString(WorkObj.value[i].c_str());
             Value[i]->SetText(WorkObj.value[i].c_str());
             }
          break;
       }
}


void TObjDialog::CmApplySelected ()
{
    // INSERT>> Your code here.
    char szBuffer[16];
    if (nCurrApply >= 0)
       {
		 ApplyAmount->GetText(szBuffer, sizeof szBuffer);
       WorkObj.affected[nCurrApply]->modifier = (sh_int) atoi(szBuffer);
       }
    // @@@ Don't think I am actually using apply-amount...

    int n = AppliesList->GetSelIndex();

    if (n < 0)
       {
         if (AppliesList->GetCount() < 2)
         	n = 0;
       }
    if (n < 0)
       {
       ApplyAmount->SetText("");
       nCurrApply = -1;
       }
    else
       {
       nCurrApply = n;
       nApplyAmount = WorkObj.affected[n]->modifier;
       wsprintf(szBuffer, "%d", nApplyAmount);
       ApplyAmount->SetText(szBuffer);
       }

    if (nCurrApply >= 0)
       {
		 ApplyAmount->GetText(szBuffer, sizeof szBuffer);
       WorkObj.affected[nCurrApply]->modifier = (sh_int) atoi(szBuffer);
       }
}


void TObjDialog::CmEditExtra ()
{
    // INSERT>> Your code here.
    int n = ExtraList->GetSelIndex();
    if (n >= 0)
       {
       if (TExtraDialog(this, WorkObj.extra_descr[n], WorkObj.AreaDoc).Execute() == IDOK)
          {
          ExtraList->DeleteString(n);
          ExtraList->InsertString(WorkObj.extra_descr[n]->keyword.c_str(), n);
          }
       }
    else
       MessageBeep(-1);
}


void TObjDialog::CmOk ()
{
    // INSERT>> Your code here.
  	 TransferData(tdGetData);
    SaveTransfer();
    TDialog::CmOk();
}

void TObjDialog::SaveValues()
{
#if 1
    // @@@ use nCurrentType
    char szBuffer[4][64];
    int32 nVal[4];
    for (int i = 0; i < 4; i++)
       {
       Value[i]->GetText(szBuffer[i], sizeof szBuffer[i]);
       nVal[i] = atol(szBuffer[i]);
       }

    switch (nCurrentType)
       {
       case ITEM_WEAPON:
          nVal[3] = TAreaDocument::DamageType(szBuffer[3]);
          break;

       case ITEM_SCROLL:
       case ITEM_POTION:
       case ITEM_PILL:
          for (i = 1; i < 4; i++)
             {
             nVal[i] = TAreaDocument::SpellValue(szBuffer[i]);
//             // @@@ Find a better way to do this...
//             if (nVal[i] == 0)
//                nVal[i] = -1;
             }
          break;

       case ITEM_TICKET:
       		// is this right?
          nVal[3] = (UPPER(szBuffer[3][0]) == 'O');
          break;

       case ITEM_WAND:
       case ITEM_STAFF:
          nVal[3] = TAreaDocument::SpellValue(szBuffer[3]);
          break;

		 case ITEM_FOUNTAIN:
       	 nVal[0] = TAreaDocument::SpellValue(szBuffer[0]);
          nVal[1] = TAreaDocument::SpellValue(szBuffer[0]);
          break;


       case ITEM_CONTAINER:
       	nVal[1] = TAreaDocument::ContainerFlags(szBuffer[1]);
         nVal[3] = TAreaDocument::ContainerTrapType(szBuffer[3]);
       	break;

       case ITEM_DRINK_CON:
		    nVal[2] = TAreaDocument::LiquidVal(szBuffer[2]);
          // Do I need this?
          nVal[3] = (UPPER(szBuffer[3][0]) == 'P');
          break;

       case ITEM_FOOD:
          // is this right?
          nVal[3] = (UPPER(szBuffer[3][0]) == 'P');
          break;
       }


   for (i = 0; i < 4; i++)
      {
      wsprintf(szBuffer[i], "%ld", nVal[i]);
      WorkObj.value[i] = szBuffer[i];
      }
#else
   char szBuffer[512];
   for (int i = 0; i < 4; i++)
      {
      Value[i]->GetText(szBuffer, sizeof szBuffer);
      WorkObj.value[i] = szBuffer;
      }

#endif
}


void TObjDialog::CmAddExtra ()
{
    // INSERT>> Your code here.
    TExtraDescr *xtra = new TExtraDescr;
    if (TExtraDialog(this, xtra, WorkObj.AreaDoc).Execute() == IDOK)
       {
       WorkObj.extra_descr.Add(xtra);
       ExtraList->AddString(xtra->keyword.c_str());
       }
    else
       delete xtra;
}


void TObjDialog::CmDelExtra ()
{
    // INSERT>> Your code here.
    int n = ExtraList->GetSelIndex();
    if (n >= 0)
       {
       ExtraList->DeleteString(n);
       WorkObj.extra_descr.Detach(n);  // @@@ Should we delete?
       }
}


void TObjDialog::CmAddApply ()
{
    // INSERT>> Your code here.

    CmApplySelected();	// Save the old apply, just in case
    int nLoc;
    if (TApplyDialog(this, &nLoc).Execute() == IDOK && nLoc > 0)
       {
       TAffect *pAff = new TAffect;
       pAff->location = (sh_int) nLoc;
       pAff->modifier = 0;
       WorkObj.affected.Add(pAff);
      // AppliesList->AddString(GetAffectName(nLoc));
       AppliesList->InsertString(GetAffectName(nLoc), ((AppliesList->GetCount())) );
       }
}


void TObjDialog::CmDelApply ()
{
    // INSERT>> Your code here.
    int n = AppliesList->GetSelIndex();
    if (n >= 0)
       {
       AppliesList->DeleteString(n);
       WorkObj.affected.Detach(n);  // @@@ Should we delete?
       }
}


void TObjDialog::CmWieldChanged ()
{
    // INSERT>> Your code here.
// @@@ Should I check for lights?
// @@@ Should I combine code with SaveTransfer?

    // Calculate current wear bits
    int32 wear = 0;
    SET_RESET_BIT(wear, Take->GetCheck() == BF_CHECKED, ITEM_TAKE);
    SET_RESET_BIT(wear, Finger->GetCheck() == BF_CHECKED, ITEM_WEAR_FINGER);
    SET_RESET_BIT(wear, Neck->GetCheck() == BF_CHECKED, ITEM_WEAR_NECK);
    SET_RESET_BIT(wear, Body->GetCheck() == BF_CHECKED, ITEM_WEAR_BODY);
    SET_RESET_BIT(wear, Head->GetCheck() == BF_CHECKED, ITEM_WEAR_HEAD);
    SET_RESET_BIT(wear, Legs->GetCheck() == BF_CHECKED, ITEM_WEAR_LEGS);
    SET_RESET_BIT(wear, Feet->GetCheck() == BF_CHECKED, ITEM_WEAR_FEET);
    SET_RESET_BIT(wear, Hands->GetCheck() == BF_CHECKED, ITEM_WEAR_HANDS);
    SET_RESET_BIT(wear, Arms->GetCheck() == BF_CHECKED, ITEM_WEAR_ARMS);
    SET_RESET_BIT(wear, Shield->GetCheck() == BF_CHECKED, ITEM_WEAR_SHIELD);
    SET_RESET_BIT(wear, AboutBody->GetCheck() == BF_CHECKED, ITEM_WEAR_ABOUT);
    SET_RESET_BIT(wear, Waist->GetCheck() == BF_CHECKED, ITEM_WEAR_WAIST);
    SET_RESET_BIT(wear, Wrist->GetCheck() == BF_CHECKED, ITEM_WEAR_WRIST);
    SET_RESET_BIT(wear, Wield->GetCheck() == BF_CHECKED, ITEM_WIELD);
    SET_RESET_BIT(wear, Hold->GetCheck() == BF_CHECKED, ITEM_HOLD);
    SET_RESET_BIT(wear, WithPride->GetCheck() == BF_CHECKED, ITEM_WORN_PRIDE);

    // Calculate nIcon
    int nIcon;
    // a non-takable thing?
    if (wear == 0)
       nIcon = 0;

    // Armor w/o take bit?
    else if ((wear & ITEM_TAKE) == 0 && (wear & ~ITEM_TAKE))
       {
       nIcon = 1;
       NoRemove->EnableWindow(FALSE);
       }

    // Just takeable, not wieldable?
    else if (wear == ITEM_TAKE)
       {
       nIcon = 2;
       NoRemove->EnableWindow(FALSE);
       }

    else
       {
       NoRemove->EnableWindow(TRUE);
       int n = 3;
       for (wear >>= 1; ; wear >>= 1, n++)
          if (wear & 1)
             { /*nIcon = n;*/ break; }

       if (wear & ~1)
          nIcon = 1;
       else
          nIcon = n;
       }

    WieldType->SendMessage(STM_SETICON, (WPARAM) hWearIcon[nIcon], 0);
}


void TObjDialog::CmHelp ()
{
    // INSERT>> Your code here.
    poundsApp::HelpState = WinHelp(HelpFileName, HELP_CONTEXT, IDD_OBJDIA);
}

