#if !defined(__objdia_h)              // Sentry, use file only if it's not already included.
#define __objdia_h

/*  Project pounds
    
    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    pounds.apx Application
    FILE:         objdia.h
    AUTHOR:       Slash


    OVERVIEW
    ========
    Class definition for TObjDialog (TDialog).      
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\button.h>
#include <owl\listbox.h>
#include <owl\static.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\edit.h>
#include <OWL\DIALOG.H>
#include <owl\combobox.h>

#include "pounds.rh"            // Definition of all resources.
#include "areadoc.h"            // Area file database

//{{TDialog = TObjDialog}}
struct TObjDialogXfer {
//{{TObjDialogXFER_DATA}}
    char    NameList[ 255 ];
    char    ShortDescr[ 255 ];
    char    LongDescr[ 2048 ];
    BOOL    Light;
    BOOL    Scroll;
    BOOL    Wand;
    BOOL    Staff;
    BOOL    Weapon;
    BOOL    Armor;
    BOOL    Potion;
    BOOL    Furniture;
    BOOL    Trash;
    BOOL    Container;
    BOOL    DrinkCon;
    BOOL    Key;
    BOOL    Food;
    BOOL    Gold;
    BOOL    Boat;
    BOOL    NPCCorpse;
    BOOL    Fountain;
    BOOL    Pill;
    BOOL    Take;
    BOOL    Finger;
    BOOL    Neck;
    BOOL    Body;
    BOOL    Head;
    BOOL    Legs;
    BOOL    Feet;
    BOOL    Hands;
    BOOL    Arms;
    BOOL    Shield;
    BOOL    AboutBody;
    BOOL    Waist;
    BOOL    Wrist;
    BOOL    Hold;
    BOOL    WithPride;
    BOOL    Glow;
    BOOL    Hum;
    BOOL    Evil;
    BOOL    Magic;
    BOOL    NoDrop;
    BOOL    AntiGood;
    BOOL    AntiEvil;
    BOOL    AntiNeutral;
    BOOL    NoRemove;
    BOOL    Invis;
	 BOOL		Good;
    BOOL		Dark;
    BOOL		Bless;
    BOOL		Inventory;
    BOOL		NoLocate;
    BOOL		Timer;
    BOOL		Sharp;
    BOOL		Dull;
    char    VNum[ 255 ];
    BOOL    Wield;
    char    Weight[ 255 ];
    BOOL    Treasure;
    TComboBoxData Value[4];
    TListBoxData  AppliesList;
    char    ApplyAmount[ 255 ];
    TListBoxData  ExtraList;
    char    Limit[ 255 ];
//    char    ObjType[ 255 ];
//    char    WieldType[ 255 ];
    BOOL    Ticket;
    BOOL		Portal;

//{{TObjDialogXFER_DATA_END}}
};


class TObjDialog : public TDialog {
    const TObject *TheActualObject;
    int nIndex;
    TObject WorkObj; // @@@
    int nCurrentType;
    int nCurrApply;
    int nApplyAmount;
    HICON hObjTypeIcon[29];
    HICON hWearIcon[18];
public:
    TObjDialog (TWindow* parent, const TObject *obj, int nNdx,
       TResId resId = IDD_OBJDIA, TModule* module = 0);
    virtual ~TObjDialog ();

//{{TObjDialogXFER_DEF}}
protected:
    TEdit *NameList;
    TEdit *ShortDescr;
    TEdit *LongDescr;
    TRadioButton *Light;
    TRadioButton *Scroll;
    TRadioButton *Wand;
    TRadioButton *Staff;
    TRadioButton *Weapon;
    TRadioButton *Armor;
    TRadioButton *Potion;
    TRadioButton *Furniture;
    TRadioButton *Trash;
    TRadioButton *Container;
    TRadioButton *DrinkCon;
    TRadioButton *Key;
    TRadioButton *Food;
    TRadioButton *Gold;
    TRadioButton *Boat;
    TRadioButton *NPCCorpse;
    TRadioButton *Fountain;
    TRadioButton *Pill;
    TCheckBox *Take;
    TCheckBox *Finger;
    TCheckBox *Neck;
    TCheckBox *Body;
    TCheckBox *Head;
    TCheckBox *Legs;
    TCheckBox *Feet;
    TCheckBox *Hands;
    TCheckBox *Arms;
    TCheckBox *Shield;
    TCheckBox *AboutBody;
    TCheckBox *Waist;
    TCheckBox *Wrist;
    TCheckBox *Hold;
    TCheckBox *WithPride;
    TCheckBox *Glow;
    TCheckBox *Hum;
    TCheckBox *Evil;
    TCheckBox *Magic;
    TCheckBox *NoDrop;
    TCheckBox *AntiGood;
    TCheckBox *AntiEvil;
    TCheckBox *AntiNeutral;
    TCheckBox *NoRemove;
    TCheckBox *Invis;
	 TCheckBox *Good;
    TCheckBox *Dark;
    TCheckBox *Bless;
    TCheckBox *Inventory;
    TCheckBox *NoLocate;
    TCheckBox *Timer;
    TCheckBox *Sharp;
    TCheckBox *Dull;
    TStatic *VNum;
    TCheckBox *Wield;
    TEdit *Weight;
    TRadioButton *Treasure;
    TStatic *Prompt[4];
    TComboBox *Value[4];
    TListBox *AppliesList;
    TEdit *ApplyAmount;
    TListBox *ExtraList;
    TStatic *ObjType;
    TStatic *WieldType;
    TStatic *Limit;
    TRadioButton *Ticket;
    TRadioButton *Portal;

//{{TObjDialogXFER_DEF_END}}
    void LoadTransfer();
    void SaveTransfer();
    void LoadAnotherObject(const TObject *);
    void SetPrompts();
    const char *GetAffectName(int n);
    void LoadValues();
    void SaveValues();

//{{TObjDialogVIRTUAL_BEGIN}}
public:
    virtual void SetupWindow ();
//{{TObjDialogVIRTUAL_END}}

//{{TObjDialogRSP_TBL_BEGIN}}
protected:
    void CmPrev ();
    void CmNext ();
    void CmTypeChanged ();
    void CmTakeChanged ();
    void CmApplySelected ();
    void CmEditExtra ();
    void CmOk ();
    void CmAddExtra ();
    void CmDelExtra ();
    void CmAddApply ();
    void CmDelApply ();
    void CmWieldChanged ();
//    void CmWaist ();
    void CmHelp ();
//{{TObjDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TObjDialog);
};    //{{TObjDialog}}


#endif                                      // __objdia_h sentry.

